module TclCompatibility (
         primPutEnv
       , primTclDebug
       , primInitTcl
       , primRunTcl
       , primRunNonBlockingTcl
       , primRunOnceTcl
       , primExecuteTcl
       , primExecuteTcl_
       , primGetEvent
       , primSetVar
       , primCheckAnyWindowsTcl
       )
where

import TclPrim hiding (primRunTcl)
import qualified TclPrim as T
import Concurrent

primRunTcl :: IO Bool
primRunTcl = do
  p <- isOnlyProcess
  if p then
     T.primRunTcl
   else do
     any <- primRunNonBlockingTcl
     if any then primCheckAnyWindowsTcl
      else do yield;primRunTcl

-- Check if the Tcl event loop is the only runnable thread.
-- if so we can safely block for input events without causing any
-- trouble     
isOnlyProcess :: IO Bool
isOnlyProcess = fmap toBool $ _casm_ ``%r = run_queue_hd == END_TSO_QUEUE;''
 where
  toBool :: Int -> Bool
  toBool 0 = False
  toBool _ = True
